Index: /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/TOOLS/SIREN/src/attribute.f90
===================================================================
--- /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/TOOLS/SIREN/src/attribute.f90	(revision 5074)
+++ /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/TOOLS/SIREN/src/attribute.f90	(revision 5075)
@@ -8,23 +8,60 @@
 !> @brief 
 !> This module manage attribute of variable or file.
-!
+!>
 !> @details
 !>    define type TATT:<br/>
-!>    TYPE(TATT) :: tl_att<br/>
+!> @code
+!>    TYPE(TATT) :: tl_att
+!> @endcode
 !>
 !>    the attribute value inside attribute structure will be
-!>    character or real(8) 1D table.<br/>
-!>    However the attribute value could be initialised with:<br/>
+!>    character or real(8) 1D array.<br/>
+!>    However the attribute value could be initialized with:<br/>
 !>    - character
 !>    - scalar (real(4), real(8), integer(4) or integer(8))
-!>    - table 1D (real(4), real(8), integer(4) or integer(8))
+!>    - array 1D (real(4), real(8), integer(4) or integer(8))
 !>
-!>    to initialise an attribute structure :<br/>
-!>    tl_att=att_init('attname',value)<br/>
-!>    tl_att=att_init('attname',tab_value)<br/>
+!>    to initialize an attribute structure :<br/>
+!> @code
+!>    tl_att=att_init('attname',value)
+!> @endcode
+!>    - value is a character, scalar value or table of value
 !>
-!>    to print attribute information of one attribute structure:<br/>
+!>    to print attribute information of one or array of attribute structure:<br/>
+!> @code
 !>    CALL att_print(td_att) 
+!> @endcode
 !>
+!>    to clean attribute structure:<br/>
+!> @code
+!>    CALL att_clean(td_att) 
+!> @endcode
+!>
+!>    to copy attribute structure in another one (using different memory cell):<br/>
+!> @code
+!>    tl_att2=att_copy(tl_att1) 
+!> @endcode
+!>    @note as we use pointer for the value array of the attribute structure,
+!>    the use of the assignment operator (=) to copy attribute structure 
+!>    create a pointer on the same array. 
+!>    This is not the case with this copy function.
+!>
+!>    to get attribute index, in an array of attribute structure:<br/>
+!> @code
+!>   il_index=att_get_index( td_att, cd_name )
+!> @endcode
+!>    - td_att array of attribute structure
+!>    - cd_name attribute name
+!> 
+!>    to get attribute id, read from a file:<br/>
+!>@code
+!>  il_id=att_get_id( td_att, cd_name )
+!>@endcode
+!>    - td_att array of attribute structure
+!>    - cd_name attribute name
+!>
+!>    to get attribute name
+!>    - tl_att\%c_name
+!> 
 !>    to get character length or the number of value store in attribute
 !>    - tl_att\%i_len
@@ -38,15 +75,13 @@
 !>    - tl_att\%i_type
 !>
-!>    to get attribute id (affected when attributes will be added to 
-!>    variable or file):<br/>
+!>    to get attribute id (read from file):<br/>
 !>    - tl_att\%i_id
 !>
-!> @author
-!> J.Paul
+!> @author J.Paul
 ! REVISION HISTORY:
-!> @date Nov, 2013 - Initial Version
+!> @date November, 2013 - Initial Version
+!> @date November, 2014 - Fix memory leaks bug
 !
 !> @note Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
-!> @todo
 !----------------------------------------------------------------------
 MODULE att
@@ -54,42 +89,44 @@
    USE global                          ! global variable
    USE kind                            ! F90 kind parameter
-   USE logger                             ! log file manager
+   USE logger                          ! log file manager
    USE fct                             ! basic useful function
    IMPLICIT NONE
-   PRIVATE
    ! NOTE_avoid_public_variables_if_possible
 
    ! type and variable
-   PUBLIC :: TATT       ! attribute structure
+   PUBLIC :: TATT       !< attribute structure
 
    ! function and subroutine
-   PUBLIC :: ASSIGNMENT(=)  ! copy attribute structure
-   PUBLIC :: att_init     ! initialize attribute structure
-   PUBLIC :: att_print    ! print attribute structure
-   PUBLIC :: att_get_id   ! get attribute id in table of attribute structure
-   PUBLIC :: att_clean    ! clean attribute strcuture
-
-   PRIVATE :: att__init_c     ! initialise an attribute structure with character value
-   PRIVATE :: att__init_dp    ! initialise an attribute structure with table of real(8) value
-   PRIVATE :: att__init_dp_0d ! initialise an attribute structure with real(8) value
-   PRIVATE :: att__init_sp    ! initialise an attribute structure with table of real(4) value
-   PRIVATE :: att__init_sp_0d ! initialise an attribute structure with real(4) value
-   PRIVATE :: att__init_i1    ! initialise an attribute structure with table of integer(1) value
-   PRIVATE :: att__init_i1_0d ! initialise an attribute structure with integer(1) value
-   PRIVATE :: att__init_i2    ! initialise an attribute structure with table of integer(2) value
-   PRIVATE :: att__init_i2_0d ! initialise an attribute structure with integer(2) value
-   PRIVATE :: att__init_i4    ! initialise an attribute structure with table of integer(4) value
-   PRIVATE :: att__init_i4_0d ! initialise an attribute structure with integer(4) value
-   PRIVATE :: att__init_i8    ! initialise an attribute structure with table of integer(8) value
-   PRIVATE :: att__init_i8_0d ! initialise an attribute structure with integer(8) value
-   PRIVATE :: att__copy_unit   ! copy attribute structure
-   PRIVATE :: att__copy_tab    ! copy attribute structure
-
-   !> @struct TATT
-   TYPE TATT
-      !CHARACTER(LEN=lc) :: c_name = 'unknown'  !< attribute name
-      CHARACTER(LEN=lc) :: c_name = ''  !< attribute name
-      INTEGER(i4)       :: i_id = 0          !< attribute id
-      INTEGER(i4)       :: i_type  = 0       !< attribute type
+   PUBLIC :: att_init       !< initialize attribute structure
+   PUBLIC :: att_print      !< print attribute structure
+   PUBLIC :: att_clean      !< clean attribute strcuture
+   PUBLIC :: att_copy       !< copy attribute structure
+   PUBLIC :: att_get_index  !< get attribute index, in an array of attribute structure
+   PUBLIC :: att_get_id     !< get attribute id, read from file
+
+   PRIVATE :: att__clean_unit ! clean attribute strcuture
+   PRIVATE :: att__clean_arr  ! clean array of attribute strcuture
+   PRIVATE :: att__print_unit ! print information on one attribute
+   PRIVATE :: att__print_arr  ! print information on a array of attribute
+   PRIVATE :: att__init_c     ! initialize an attribute structure with character value
+   PRIVATE :: att__init_dp    ! initialize an attribute structure with array of real(8) value
+   PRIVATE :: att__init_dp_0d ! initialize an attribute structure with real(8) value
+   PRIVATE :: att__init_sp    ! initialize an attribute structure with array of real(4) value
+   PRIVATE :: att__init_sp_0d ! initialize an attribute structure with real(4) value
+   PRIVATE :: att__init_i1    ! initialize an attribute structure with array of integer(1) value
+   PRIVATE :: att__init_i1_0d ! initialize an attribute structure with integer(1) value
+   PRIVATE :: att__init_i2    ! initialize an attribute structure with array of integer(2) value
+   PRIVATE :: att__init_i2_0d ! initialize an attribute structure with integer(2) value
+   PRIVATE :: att__init_i4    ! initialize an attribute structure with array of integer(4) value
+   PRIVATE :: att__init_i4_0d ! initialize an attribute structure with integer(4) value
+   PRIVATE :: att__init_i8    ! initialize an attribute structure with array of integer(8) value
+   PRIVATE :: att__init_i8_0d ! initialize an attribute structure with integer(8) value
+   PRIVATE :: att__copy_unit  ! copy attribute structure
+   PRIVATE :: att__copy_arr   ! copy array of attribute structure
+
+   TYPE TATT !< attribute structure
+      CHARACTER(LEN=lc) :: c_name = ''       !< attribute name
+      INTEGER(i4)       :: i_id   = 0        !< attribute id
+      INTEGER(i4)       :: i_type = 0        !< attribute type
       INTEGER(i4)       :: i_len  = 0        !< number of value store in attribute
       CHARACTER(LEN=lc) :: c_value = "none"  !< attribute value if type CHAR
@@ -113,34 +150,47 @@
    END INTERFACE att_init
 
-   INTERFACE ASSIGNMENT(=)
-      MODULE PROCEDURE att__copy_unit   ! copy attribute structure
-      MODULE PROCEDURE att__copy_tab   ! copy attribute structure
+   INTERFACE att_print
+      MODULE PROCEDURE att__print_unit ! print information on one attribute
+      MODULE PROCEDURE att__print_arr  ! print information on a array of attribute
+   END INTERFACE att_print
+
+   INTERFACE att_clean
+      MODULE PROCEDURE att__clean_unit  
+      MODULE PROCEDURE att__clean_arr   
    END INTERFACE
 
+   INTERFACE att_copy
+      MODULE PROCEDURE att__copy_unit  ! copy attribute structure
+      MODULE PROCEDURE att__copy_arr   ! copy array of attribute structure
+   END INTERFACE
+
 CONTAINS
    !-------------------------------------------------------------------
    !> @brief
-   !> This function copy attribute structure in another attribute
-   !> structure
+   !> This subroutine copy a array of attribute structure in another one
    !> @details 
-   !> attribute value are copied in a temporary table, so input and output
-   !> attribute structure value do not point on the same "memory cell", and so
-   !> on are independant. 
-   !>
+   !> see att__copy_unit
+   !>
+   !> @warning do not use on the output of a function who create or read an
+   !> attribute (ex: tl_att=att_copy(att_init()) is forbidden).
+   !> This will create memory leaks.
    !> @warning to avoid infinite loop, do not use any function inside 
    !> this subroutine
    !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[out] td_att1  : attribute structure
-   !> @param[in] td_att2  : attribute structure
-   !-------------------------------------------------------------------
-   ! @code
-   SUBROUTINE att__copy_tab( td_att1, td_att2 )
-      IMPLICIT NONE
-      ! Argument
-      TYPE(TATT), DIMENSION(:)               , INTENT(IN) :: td_att2
-      TYPE(TATT), DIMENSION(SIZE(td_att2(:))),INTENT(OUT) :: td_att1
+   !> @date November, 2013 - Initial Version
+   !> @date November, 2014
+   !>    - use function instead of overload assignment operator 
+   !> (to avoid memory leak) 
+   !
+   !> @param[in] td_att   array of attribute structure
+   !> @return copy of input array of attribute structure
+   !-------------------------------------------------------------------
+   FUNCTION att__copy_arr( td_att )
+      IMPLICIT NONE
+      ! Argument
+      TYPE(TATT), DIMENSION(:), INTENT(IN) :: td_att
+      ! function
+      TYPE(TATT), DIMENSION(SIZE(td_att(:))) :: att__copy_arr
 
       ! local variable
@@ -149,34 +199,37 @@
       !----------------------------------------------------------------
 
-      DO ji=1,SIZE(td_att2(:))
-         td_att1(ji)=td_att2(ji)
+      DO ji=1,SIZE(td_att(:))
+         att__copy_arr(ji)=att_copy(td_att(ji))
       ENDDO
 
-   END SUBROUTINE att__copy_tab
-   ! @endcode
+   END FUNCTION att__copy_arr
    !-------------------------------------------------------------------
    !> @brief
-   !> This function copy attribute structure in another attribute
-   !> structure
+   !> This subroutine copy an attribute structure in another one.
    !> @details 
-   !> attribute value are copied in a temporary table, so input and output
+   !> attribute value are copied in a temporary array, so input and output
    !> attribute structure value do not point on the same "memory cell", and so
    !> on are independant. 
    !>
+   !> @warning do not use on the output of a function who create or read an
+   !> attribute (ex: tl_att=att_copy(att_init()) is forbidden).
+   !> This will create memory leaks.
    !> @warning to avoid infinite loop, do not use any function inside 
    !> this subroutine
    !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[out] td_att1  : attribute structure
-   !> @param[in] td_att2  : attribute structure
-   !-------------------------------------------------------------------
-   ! @code
-   SUBROUTINE att__copy_unit( td_att1, td_att2 )
-      IMPLICIT NONE
-      ! Argument
-      TYPE(TATT), INTENT(OUT) :: td_att1
-      TYPE(TATT), INTENT(IN)  :: td_att2
+   !> @date November, 2013 - Initial Version
+   !> @date November, 2014
+   !> - use function instead of overload assignment operator (to avoid memory leak) 
+   !>
+   !> @param[in] td_att   attribute structure
+   !> @return copy of input attribute structure
+   !-------------------------------------------------------------------
+   FUNCTION att__copy_unit( td_att )
+      IMPLICIT NONE
+      ! Argument
+      TYPE(TATT), INTENT(IN)  :: td_att
+      ! function
+      TYPE(TATT) :: att__copy_unit
 
       ! local variable
@@ -184,40 +237,38 @@
       !----------------------------------------------------------------
 
-      CALL logger_trace("COPY: attribute "//TRIM(td_att2%c_name) )
-
       ! copy attribute variable
-      td_att1%c_name  = TRIM(td_att2%c_name)
-      td_att1%i_id    = td_att2%i_id
-      td_att1%i_type  = td_att2%i_type
-      td_att1%i_len   = td_att2%i_len
-      td_att1%c_value = TRIM(td_att2%c_value)
+      att__copy_unit%c_name  = TRIM(td_att%c_name)
+      att__copy_unit%i_id    = td_att%i_id
+      att__copy_unit%i_type  = td_att%i_type
+      att__copy_unit%i_len   = td_att%i_len
+      att__copy_unit%c_value = TRIM(td_att%c_value)
 
       ! copy attribute pointer in an independant variable
-      IF( ASSOCIATED(td_att1%d_value) ) DEALLOCATE(td_att1%d_value)
-      IF( ASSOCIATED(td_att2%d_value) )THEN
-         ALLOCATE( dl_value(td_att2%i_len) )
-         dl_value(:) = td_att2%d_value(:)
-
-         ALLOCATE( td_att1%d_value(td_att1%i_len) )
-         td_att1%d_value(:) = dl_value(:)
+      IF( ASSOCIATED(att__copy_unit%d_value) ) DEALLOCATE(att__copy_unit%d_value)
+      IF( ASSOCIATED(td_att%d_value) )THEN
+         ALLOCATE( dl_value(td_att%i_len) )
+         dl_value(:) = td_att%d_value(:)
+
+         ALLOCATE( att__copy_unit%d_value(att__copy_unit%i_len) )
+         att__copy_unit%d_value(:) = dl_value(:)
 
          DEALLOCATE( dl_value )
       ENDIF
 
-   END SUBROUTINE att__copy_unit
-   ! @endcode
-   !-------------------------------------------------------------------
-   !> @brief This function get attribute id, in a table of attribute structure,
-   !> given attribute name
-   !>
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_att  : attribute structure
-   !> @param[in] cd_name : attribute name
-   !> @return attribute id
-   !-------------------------------------------------------------------
-   ! @code
-   INTEGER(i4) FUNCTION att_get_id( td_att, cd_name )
+   END FUNCTION att__copy_unit
+   !-------------------------------------------------------------------
+   !> @brief This function return attribute index, in a array of attribute structure,
+   !> given attribute name.<br/>
+   !> @details
+   !> if attribute name do not exist, return 0.
+   !>
+   !> @author J.Paul
+   !> @date Septempber, 2014 - Initial Version
+   !
+   !> @param[in] td_att    array of attribute structure
+   !> @param[in] cd_name   attribute name
+   !> @return attribute index
+   !-------------------------------------------------------------------
+   INTEGER(i4) FUNCTION att_get_index( td_att, cd_name )
       IMPLICIT NONE
       ! Argument
@@ -231,28 +282,62 @@
       INTEGER(i4) :: ji
       !----------------------------------------------------------------
-      att_get_id=0
+      att_get_index=0
 
       il_size=SIZE(td_att(:))
       DO ji=1,il_size
          IF( TRIM(td_att(ji)%c_name) == TRIM(cd_name) )THEN
-            att_get_id=ji
+            att_get_index=ji
             EXIT
          ENDIF
       ENDDO
 
+   END FUNCTION att_get_index
+   !-------------------------------------------------------------------
+   !> @brief This function return attribute id, read from a file.<br/>
+   !> @details
+   !> if attribute name do not exist, return 0.
+   !>
+   !> @author J.Paul
+   !> @date November, 2013 - Initial Version
+   !> @date September, 2014 - bug fix with use of id read from attribute structure
+   !
+   !> @param[in] td_att    array of attribute structure
+   !> @param[in] cd_name   attribute name
+   !> @return attribute id
+   !-------------------------------------------------------------------
+   INTEGER(i4) FUNCTION att_get_id( td_att, cd_name )
+      IMPLICIT NONE
+      ! Argument
+      TYPE(TATT),       DIMENSION(:), INTENT(IN) :: td_att
+      CHARACTER(LEN=*),               INTENT(IN) :: cd_name
+
+      ! local variable
+      INTEGER(i4) :: il_size
+
+      ! loop indices
+      INTEGER(i4) :: ji
+      !----------------------------------------------------------------
+      att_get_id=0
+
+      il_size=SIZE(td_att(:))
+      DO ji=1,il_size
+         IF( TRIM(td_att(ji)%c_name) == TRIM(cd_name) )THEN
+            att_get_id=td_att(ji)%i_id
+            EXIT
+         ENDIF
+      ENDDO
+
    END FUNCTION att_get_id
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This function initialise an attribute structure with character
-   !> value 
-   !>
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] cd_name : attribute name
-   !> @param[in] cd_value: attribute value
+   !-------------------------------------------------------------------
+   !> @brief This function initialize an attribute structure with character
+   !> value. 
+   !>
+   !> @author J.Paul
+   !> @date November, 2013 - Initial Version
+   !
+   !> @param[in] cd_name   attribute name
+   !> @param[in] cd_value  attribute value
    !> @return attribute structure
    !-------------------------------------------------------------------
-   !> @code
    TYPE(TATT) FUNCTION att__init_c( cd_name, cd_value )
       IMPLICIT NONE
@@ -265,5 +350,5 @@
       CALL att_clean(att__init_c)
 
-      CALL logger_info( &
+      CALL logger_trace( &
       &  " ATT INIT: attribute name: "//TRIM(ADJUSTL(cd_name))//&
       &  " attribute value "//TRIM(ADJUSTL(cd_value)) )
@@ -276,18 +361,19 @@
 
    END FUNCTION att__init_c
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This function initialise an attribute structure with table 
-   !> of real(8) value
-   !>
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] cd_name : attribute name
-   !> @param[in] dd_value: attribute value
+   !-------------------------------------------------------------------
+   !> @brief This function initialize an attribute structure with array 
+   !> of real(8) value.
+   !> @details
+   !> Optionaly you could specify the type of the variable to be saved.
+   !>
+   !> @author J.Paul
+   !> @dtae November, 2013 - Initial Version
+   !
+   !> @param[in] cd_name   attribute name
+   !> @param[in] dd_value  attribute value
+   !> @param[in] id_type   type of the variable to be saved
    !> @return attribute structure
    !-------------------------------------------------------------------
-   !> @code
-   TYPE(TATT) FUNCTION att__init_dp( cd_name, dd_value )
+   TYPE(TATT) FUNCTION att__init_dp( cd_name, dd_value, id_type )
       IMPLICIT NONE
 
@@ -295,4 +381,5 @@
       CHARACTER(LEN=*),               INTENT(IN) :: cd_name
       REAL(dp),         DIMENSION(:), INTENT(IN) :: dd_value
+      INTEGER(i4)                   , INTENT(IN), OPTIONAL :: id_type
 
       ! local value
@@ -307,5 +394,5 @@
       CALL att_clean(att__init_dp)
 
-      ! table size
+      ! array size
       il_len=size(dd_value(:))
 
@@ -316,5 +403,5 @@
       cl_value=TRIM(cl_value)//TRIM(fct_str(dd_value(il_len)))//"/)"
 
-      CALL logger_info( &
+      CALL logger_trace( &
       &  " ATT INIT: attribute name: "//TRIM(ADJUSTL(cd_name))//&
       &  " attribute value "//TRIM(ADJUSTL(cl_value)) )
@@ -322,5 +409,9 @@
       att__init_dp%c_name=TRIM(ADJUSTL(cd_name))
 
-      att__init_dp%i_type=NF90_DOUBLE
+      IF( PRESENT(id_type) )THEN
+         att__init_dp%i_type=id_type
+      ELSE
+         att__init_dp%i_type=NF90_DOUBLE
+      ENDIF
 
       IF( ASSOCIATED(att__init_dp%d_value) )THEN
@@ -333,22 +424,24 @@
 
    END FUNCTION att__init_dp
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This function initialise an attribute structure with 
+   !-------------------------------------------------------------------
+   !> @brief This function initialize an attribute structure with 
    !> real(8) value 
-   !>
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] cd_name : attribute name
-   !> @param[in] dd_value: attribute value
+   !> @details
+   !> Optionaly you could specify the type of the variable to be saved.
+   !>
+   !> @author J.Paul
+   !> @date November, 2013 - Initial Version
+   !
+   !> @param[in] cd_name   attribute name
+   !> @param[in] dd_value  attribute value
+   !> @param[in] id_type   type of the variable to be saved
    !> @return attribute structure
    !-------------------------------------------------------------------
-   !> @code
-   TYPE(TATT) FUNCTION att__init_dp_0d( cd_name, dd_value )
+   TYPE(TATT) FUNCTION att__init_dp_0d( cd_name, dd_value, id_type )
       IMPLICIT NONE
       ! Argument
       CHARACTER(LEN=*), INTENT(IN) :: cd_name
       REAL(dp),         INTENT(IN) :: dd_value
+      INTEGER(i4)     , INTENT(IN), OPTIONAL :: id_type
 
       ! local value
@@ -361,5 +454,5 @@
       cl_value="(/"//TRIM(fct_str(dd_value))//"/)"
 
-      CALL logger_info( &
+      CALL logger_trace( &
       &  " ATT INIT: attribute name: "//TRIM(ADJUSTL(cd_name))//&
       &  " attribute value "//TRIM(ADJUSTL(cl_value)) )
@@ -367,5 +460,9 @@
       att__init_dp_0d%c_name=TRIM(ADJUSTL(cd_name))
 
-      att__init_dp_0d%i_type=NF90_DOUBLE
+      IF( PRESENT(id_type) )THEN
+         att__init_dp_0d%i_type=id_type
+      ELSE
+         att__init_dp_0d%i_type=NF90_DOUBLE
+      ENDIF
 
       IF( ASSOCIATED(att__init_dp_0d%d_value) )THEN
@@ -378,22 +475,24 @@
 
    END FUNCTION att__init_dp_0d
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This function initialise an attribute structure with table 
-   !> of real(4) value
-   !>
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] cd_name : attribute name
-   !> @param[in] rd_value: attribute value
+   !-------------------------------------------------------------------
+   !> @brief This function initialize an attribute structure with array 
+   !> of real(4) value.
+   !> @details
+   !> Optionaly you could specify the type of the variable to be saved.
+   !>
+   !> @author J.Paul
+   !> @date November, 2013 - Initial Version
+   !
+   !> @param[in] cd_name   attribute name
+   !> @param[in] rd_value  attribute value
+   !> @param[in] id_type   type of the variable to be saved
    !> @return attribute structure
    !-------------------------------------------------------------------
-   !> @code
-   TYPE(TATT) FUNCTION att__init_sp( cd_name, rd_value )
+   TYPE(TATT) FUNCTION att__init_sp( cd_name, rd_value, id_type )
       IMPLICIT NONE
       ! Argument
       CHARACTER(LEN=*),               INTENT(IN) :: cd_name
       REAL(sp),         DIMENSION(:), INTENT(IN) :: rd_value
+      INTEGER(i4)                   , INTENT(IN), OPTIONAL :: id_type
 
       ! local value
@@ -408,5 +507,5 @@
       CALL att_clean(att__init_sp)
       
-      ! table size
+      ! array size
       il_len=size(rd_value(:))
 
@@ -417,5 +516,5 @@
       cl_value=TRIM(cl_value)//TRIM(fct_str(rd_value(il_len)))//"/)"
 
-      CALL logger_info( &
+      CALL logger_trace( &
       &  " ATT INIT: attribute name: "//TRIM(ADJUSTL(cd_name))//&
       &  " attribute value "//TRIM(ADJUSTL(cl_value)) )      
@@ -423,5 +522,9 @@
       att__init_sp%c_name=TRIM(ADJUSTL(cd_name))
 
-      att__init_sp%i_type=NF90_FLOAT
+      IF( PRESENT(id_type) )THEN
+         att__init_sp%i_type=id_type
+      ELSE
+         att__init_sp%i_type=NF90_FLOAT
+      ENDIF
 
       IF( ASSOCIATED(att__init_sp%d_value) )THEN
@@ -434,22 +537,24 @@
 
    END FUNCTION att__init_sp
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This function initialise an attribute structure with 
-   !> real(4) value 
-   !>
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] cd_name : attribute name
-   !> @param[in] rd_value: attribute value
+   !-------------------------------------------------------------------
+   !> @brief This function initialize an attribute structure with 
+   !> real(4) value. 
+   !> @details
+   !> Optionaly you could specify the type of the variable to be saved.
+   !>
+   !> @author J.Paul
+   !> @date November, 2013 - Initial Version
+   !
+   !> @param[in] cd_name   attribute name
+   !> @param[in] rd_value  attribute value
+   !> @param[in] id_type   type of the variable to be saved
    !> @return attribute structure
    !-------------------------------------------------------------------
-   !> @code
-   TYPE(TATT) FUNCTION att__init_sp_0d( cd_name, rd_value )
+   TYPE(TATT) FUNCTION att__init_sp_0d( cd_name, rd_value, id_type )
       IMPLICIT NONE
       ! Argument
       CHARACTER(LEN=*), INTENT(IN) :: cd_name
       REAL(sp),         INTENT(IN) :: rd_value
+      INTEGER(i4)     , INTENT(IN), OPTIONAL :: id_type
 
       ! local value
@@ -462,5 +567,5 @@
       cl_value="(/"//TRIM(fct_str(rd_value))//"/)"
 
-      CALL logger_info( &
+      CALL logger_trace( &
       &  " ATT INIT: attribute name: "//TRIM(ADJUSTL(cd_name))//&
       &  " attribute value "//TRIM(ADJUSTL(cl_value)) )      
@@ -468,5 +573,9 @@
       att__init_sp_0d%c_name=TRIM(ADJUSTL(cd_name))
 
-      att__init_sp_0d%i_type=NF90_FLOAT
+      IF( PRESENT(id_type) )THEN
+         att__init_sp_0d%i_type=id_type
+      ELSE
+         att__init_sp_0d%i_type=NF90_FLOAT
+      ENDIF
 
       IF( ASSOCIATED(att__init_sp_0d%d_value) )THEN
@@ -479,22 +588,24 @@
 
    END FUNCTION att__init_sp_0d
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This function initialise an attribute structure with table 
-   !> of integer(1) value
-   !>
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] cd_name : attribute name
-   !> @param[in] bd_value: attribute value
+   !-------------------------------------------------------------------
+   !> @brief This function initialize an attribute structure with array 
+   !> of integer(1) value.
+   !> @details
+   !> Optionaly you could specify the type of the variable to be saved.
+   !>
+   !> @author J.Paul
+   !> @date November, 2013 - Initial Version
+   !
+   !> @param[in] cd_name   attribute name
+   !> @param[in] bd_value  attribute value
+   !> @param[in] id_type   type of the variable to be saved
    !> @return attribute structure
    !-------------------------------------------------------------------
-   !> @code
-   TYPE(TATT) FUNCTION att__init_i1( cd_name, bd_value )
+   TYPE(TATT) FUNCTION att__init_i1( cd_name, bd_value, id_type )
       IMPLICIT NONE
       ! Argument
       CHARACTER(LEN=*),               INTENT(IN) :: cd_name
       INTEGER(i1),      DIMENSION(:), INTENT(IN) :: bd_value
+      INTEGER(i4)                   , INTENT(IN), OPTIONAL :: id_type
 
       ! local value
@@ -509,5 +620,5 @@
       CALL att_clean(att__init_i1)
       
-      ! table size
+      ! array size
       il_len=size(bd_value(:))
 
@@ -518,5 +629,5 @@
       cl_value=TRIM(cl_value)//TRIM(fct_str(bd_value(il_len)))//"/)"
 
-      CALL logger_info( &
+      CALL logger_trace( &
       &  " ATT INIT: attribute name: "//TRIM(ADJUSTL(cd_name))//&
       &  " attribute value "//TRIM(ADJUSTL(cl_value)) )      
@@ -524,5 +635,9 @@
       att__init_i1%c_name=TRIM(ADJUSTL(cd_name))
 
-      att__init_i1%i_type=NF90_BYTE
+      IF( PRESENT(id_type) )THEN
+         att__init_i1%i_type=id_type
+      ELSE
+         att__init_i1%i_type=NF90_BYTE
+      ENDIF
 
       IF( ASSOCIATED(att__init_i1%d_value) )THEN
@@ -535,22 +650,24 @@
 
    END FUNCTION att__init_i1
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This function initialise an attribute structure with 
-   !> integer(1) value 
-   !>
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] cd_name : attribute name
-   !> @param[in] bd_value: attribute value
+   !-------------------------------------------------------------------
+   !> @brief This function initialize an attribute structure with 
+   !> integer(1) value. 
+   !> @details
+   !> Optionaly you could specify the type of the variable to be saved.
+   !>
+   !> @author J.Paul
+   !> @date November, 2013 - Initial Version
+   !
+   !> @param[in] cd_name   attribute name
+   !> @param[in] bd_value  attribute value
+   !> @param[in] id_type   type of the variable to be saved
    !> @return attribute structure
    !-------------------------------------------------------------------
-   !> @code
-   TYPE(TATT) FUNCTION att__init_i1_0d( cd_name, bd_value )
+   TYPE(TATT) FUNCTION att__init_i1_0d( cd_name, bd_value, id_type )
       IMPLICIT NONE
       ! Argument
       CHARACTER(LEN=*), INTENT(IN) :: cd_name
       INTEGER(i1),      INTENT(IN) :: bd_value
+      INTEGER(i4)     , INTENT(IN), OPTIONAL :: id_type
 
       !local value
@@ -563,5 +680,5 @@
       cl_value="(/"//TRIM(fct_str(bd_value))//"/)"
 
-      CALL logger_info( &
+      CALL logger_trace( &
       &  " ATT INIT: attribute name: "//TRIM(ADJUSTL(cd_name))//&
       &  " attibute value "//TRIM(ADJUSTL(cl_value)) )      
@@ -569,5 +686,9 @@
       att__init_i1_0d%c_name=TRIM(ADJUSTL(cd_name))
 
-      att__init_i1_0d%i_type=NF90_BYTE
+      IF( PRESENT(id_type) )THEN
+         att__init_i1_0d%i_type=id_type
+      ELSE
+         att__init_i1_0d%i_type=NF90_BYTE
+      ENDIF      
 
       IF( ASSOCIATED(att__init_i1_0d%d_value) )THEN
@@ -580,22 +701,24 @@
 
    END FUNCTION att__init_i1_0d
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This function initialise an attribute structure with table 
-   !> of integer(2) value
-   !>
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] cd_name : attribute name
-   !> @param[in] sd_value: attribute value
+   !-------------------------------------------------------------------
+   !> @brief This function initialize an attribute structure with array 
+   !> of integer(2) value.
+   !> @details
+   !> Optionaly you could specify the type of the variable to be saved.
+   !>
+   !> @author J.Paul
+   !> @date November, 2013 - Initial Version
+   !
+   !> @param[in] cd_name   attribute name
+   !> @param[in] sd_value  attribute value
+   !> @param[in] id_type   type of the variable to be saved
    !> @return attribute structure
    !-------------------------------------------------------------------
-   !> @code
-   TYPE(TATT) FUNCTION att__init_i2( cd_name, sd_value )
+   TYPE(TATT) FUNCTION att__init_i2( cd_name, sd_value, id_type )
       IMPLICIT NONE
       ! Argument
       CHARACTER(LEN=*),               INTENT(IN) :: cd_name
       INTEGER(i2),      DIMENSION(:), INTENT(IN) :: sd_value
+      INTEGER(i4)                   , INTENT(IN), OPTIONAL :: id_type
 
       ! local value
@@ -610,5 +733,5 @@
       CALL att_clean(att__init_i2)
       
-      ! table size
+      ! array size
       il_len=size(sd_value(:))
 
